package com.yihu.hos.arbiter.configuration;

import io.zbus.mq.Broker;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @author Airhead
 * @since 2016/12/9.
 */
@Configuration
public class ArbiterServerConfiguration {
    @Value("${arbiter.central.url}")
    private String centralUrl;
    @Value("${arbiter.tenant.name}")
    private String tenant;

    @Value("${arbiter.mycat.name}")
    private String mycatName;


    private Broker broker;


    public String getMycatName() {
        return mycatName;
    }

    public String getCentralUrl() {
        return centralUrl;
    }


    public String getTenant() {
        return tenant;
    }

    @Bean
    public Broker getBroker() {
        broker = new Broker(this.centralUrl);

        return broker;
    }

    @Override
    protected void finalize() throws Throwable {
        if (broker != null) {
            broker.close();
        }

        super.finalize();
    }
}
